
-- hud stuff
-- who needs boring default srb2 hud
-- when i can just recreate sunky the game hud!!!!!!!!!!!!!!!!
-- P.S: i dont even know if this works properly in multiplayer

local intframe = 1
local inttime = 0

addHook("ThinkFrame", function()
	intframe = 1 -- if you aren't in the intermission then the frame should be the first one.
	inttime = 0 -- also reset the timer to increase frames!!!!

	if not consoleplayer return end -- make this only happen if you're the player appearing on the screen
	
	local p = consoleplayer
	
	p.sunkymusic = S_MusicName(p)
	
	if skins[p.skin].name ~= "sunky"
	and p.sunkhud
		hud.enable("intermissiontitletext")
		hud.enable("intermissiontally")
		hud.enable("stagetitle")
		p.sunkhud = false
	elseif skins[p.skin].name == "sunky"
	and not p.sunkhud
		hud.disable("intermissiontitletext")
		hud.disable("intermissiontally")
		hud.disable("stagetitle")
		p.sunkhud = true
	end
	
	/*local ut = FixedDiv(2*FU, FixedDiv(18, 100))/FU
	if p.sunklyric == nil
	or S_MusicName(p) ~= "LTGRON"
	or S_GetMusicPosition() < 5*MUSICRATE+500
		p.sunklyric = {
			frame = 0,
			time = ut,
			timeup = 0
		}
	else
		local l = p.sunklyric
		if l.frame >= 154
			l.timeup = $+1
		end
		l.time = ($ > 0 and $-1) or ut
		l.frame = (l.time == ut and $+1) or $
	end*/
end)

local maxtime = TICRATE/6

addHook("HUD", function(v)
	if not consoleplayer return end -- you shouldnt see this if you aren't the console player yay!!!!!!!!!!
	local p = consoleplayer
	
	if skins[p.skin].name ~= "sunky" return end -- get out of here, you gotta be sunky!!!!
	
	if consoleplayer == server -- only add a frame if you're the server, don't want multiple frames going up when there's more than one player.
		inttime = $+1
		if inttime%2 == 0
		and inttime > maxtime
			intframe = min($+1, 5) -- we don't want inexistent frames happening, do we?
		end
	end
	
	local scale = FU/3
	local utime = min(FixedDiv(inttime, maxtime), FU)
	local ease1 = ease.linear(utime, 0, FixedDiv(320, 2))
	local ease2 = ease.linear(utime, 320*FU, FixedDiv(320, 2))
	if inttime < maxtime
		v.drawScaled(ease1, 32*FU, scale, v.cachePatch("SUNKYTGO"), V_SNAPTOTOP|V_PERPLAYER) -- TGO is for The Green One, since i got that from one of the frames of well, Level The Green One's title card
		v.drawScaled(ease2, 32*FU, scale, v.cachePatch("SUNKYBADCIRC"), V_SNAPTOTOP|V_PERPLAYER) -- bad circle is because it's a bad circle, that i quickly drew to have something to use
	else
		v.drawScaled(ease1, 32*FU, scale, v.cachePatch("SUNKYDAT"+intframe), V_SNAPTOTOP|V_PERPLAYER) -- i only really named it SUNKYDAT because DAT is just a shorter way to write Did a Thing :DDDDD
	end
end, "intermission")

local function drawsunk(v, x, y, hscale, vscale, str, flags, scale)
	if v == nil return end
	
	x = $ or 0
	y = $ or 0
	scale = $ or FU
	hscale = FixedMul($, scale) or scale
	vscale = FixedMul($, scale) or scale
	str = tostring($) or "im dead"
	flags = $ or 0
	
	local leng = string.len(str)
	local ux = x
	for i = 0, leng-1 do
		local curLet = string.upper(string.sub(str, leng-i, leng-i))
		if not v.patchExists("SUNKFNT"+curLet) ux = $-24*hscale continue end
		
		local patch = v.cachePatch("SUNKFNT"+curLet)
		v.drawStretched(ux, y, hscale, vscale, patch, flags)
		ux = $-(patch.width)*hscale
	end
end

sfxinfo[freeslot("sfx_snkswp")].caption = "Swipe"
sfxinfo[freeslot("sfx_snkdsh")].caption = "Dash"

addHook("HUD", function(v, p, tic, mtic)
	if skins[p.skin].name ~= "sunky" return end
	
	if tic >= mtic return end
	
	if tic == 1
	and not S_SoundPlaying(p.mo, sfx_snkswp)
		S_StartSound(p.mo, sfx_snkswp, p)
	elseif tic == 52
	and not S_SoundPlaying(p.mo, sfx_snkdsh)
		S_StartSound(p.mo, sfx_snkdsh, p)
	end
	
	local scale = FU/3
	local tscale = scale+FU/6
	local flags = 0
	local mh = mapheaderinfo[gamemap]
	
	local xtime = FixedDiv(min(tic, maxtime), maxtime)
	local xease = ease.linear(xtime, 0, 160*FU)
	local xease2 = ease.linear(xtime, 320*FU, 160*FU)
	
	local mtime = TICRATE/3
	local aht = max(FixedDiv(min(tic-maxtime, mtime), mtime), 0) --aht stands for actual htime
	local htime = (tic > maxtime and aht) or FU
	local hease = ease.outback(htime, FU/5, FU, FU/5*2)
	
	local vtime = max(FixedDiv(min(tic-maxtime-mtime-TICRATE, TICRATE/4), TICRATE/4), 0) -- i swear, this is just a mess now.
	local vease = ease.insine(vtime, FU, FU/2)
	hease = (vtime > 0 and ease.insine(vtime, FU, FU+FU/3)) or $
	
	local p2time = 40*(60/35)-TICRATE/2-TICRATE/4 -- converts the actual time frame sunky the game (part 1) uses, and then removes the extra time we used to squash and stretch
	local up2t = max(FixedDiv(tic-maxtime-mtime-TICRATE-TICRATE/4, p2time), 0) -- up2t stands for use part 2 time (the actual time to use in the ease part), it is also, just a messy mess please help
	vease = (up2t > 0 and ease.outsine(min(up2t, FU), FU/2, FU*2)) or $
	hease = (up2t > 0 and ease.outsine(min(up2t, FU), FU+FU/3, FU/3)) or $
	
	local yease = (vease > FU and ease.outsine(min(up2t-FU/4, FU), 0, 562*FU)) or 0
	
	--local timer = mtic-(maxtime+mtime+p2time+TICRATE/2) -- timer actually stands for time remaining
	--local istitl = max(FixedDiv(min(tic-maxtime-mtime-TICRATE/2-TICRATE/4-p2time-TICRATE/2, TICRATE/5), TICRATE/5), 0) -- it stands for i swear this is too long
	--local yease = ease.outsine(istitl, 0, 100*FU)
	-- REMINDER TO SELF: sfx should play 12 frames before going up
	
	v.drawStretched(xease2, 100*FU-FixedMul(90*scale, vease)-yease, FixedMul(hease, scale), FixedMul(vease, scale), v.cachePatch("SUNKYCARD"), flags)
	--v.drawScaled(160*FU, 100*FU-90*scale, scale, v.cachePatch("TEST"), flags)
	local mnum = string.match(mh.lvlttl, " ")
	mnum = ($ ~= nil and string.len($)+1) or 1
	local space = string.find(mh.lvlttl, " ")
	
	for i = 1, mnum do
		space = (space ~= nil and $-1) or $
		if i == 1
			drawsunk(v, xease+FixedMul(20*FU, hease), 100*FU-FixedMul(25*FU, vease)-yease, hease, vease, string.sub(mh.lvlttl, 0, space), flags, tscale)
		else
			drawsunk(v, xease+FixedMul(20*FU, hease), 100*FU-FixedMul(25*FU-30*(i-1)*tscale, vease)-yease, hease, vease, string.sub(mh.lvlttl, space+2), flags, tscale)
		end
		space = string.find(mh.lvlttl, " ", $)
	end
end, "titlecard")

local oframe = 0

addHook("HUD", function(v)
	if not consoleplayer
	or consoleplayer.sunkymusic ~= "LTGRON" return end
	
	local p = consoleplayer
	
	local stime = 5*MUSICRATE+500
	local time2 = 54*FixedDiv(60, TICRATE)/TICRATE
	local pos = FixedDiv(S_GetMusicPosition(), MUSICRATE)
	local pos2 = max(pos-FixedDiv(stime, MUSICRATE), 0)
	local leng = FixedDiv(53870, MUSICRATE)
	--local leng2 = FixedDiv(S_GetMusicLength(), MUSICRATE)
	--local pos3 = max(pos2-(leng-FixedDiv(stime, MUSICRATE)+time2), 0)
	local lyric = ease.linear(FixedDiv(pos2, leng-FixedDiv(stime, MUSICRATE)), 0, 153*FU)
	/*if pos2 < leng-FixedDiv(stime, MUSICRATE)
		print((leng-pos2)/FU)
	else*/if pos2 >= leng-FixedDiv(stime, MUSICRATE)
	and pos2 <= leng+time2-FixedDiv(stime, MUSICRATE)
		lyric = 0
		--print((leng+time2-FixedDiv(stime, MUSICRATE))/FU, pos2/FU)
	elseif pos2 > leng+time2-FixedDiv(stime, MUSICRATE)
		lyric = max($-8*FU, 154*FU)
		--lyric = ease.linear(FixedDiv(pos3, leng2-FixedDiv(stime, MUSICRATE)), 154*FU, 234*FU)
		--print(FixedRound(pos3)/FU)
	end
	lyric = $/FU
	
	if lyric <= 0 return end
	
	v.drawScaled(160*FU, 200*FU-FixedDiv(223, 3), FU/3, v.cachePatch("SUNKLYRIC"+lyric))
	
	--SUNKLYRIC154.lmp is the first lyrics 4 one
end, "game")