
-- he's accurate now
-- haha

local function dontdoStuff(p, fan)
	fan = $ or true
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or (p.pflags & PF_SLIDING)
	or p.powers[pw_carry]
	or (p.mo.state == S_SUNKY_FAN and fan)
		return true
	end
	return false
end

local function shouldMove(p)
	if dontdoStuff(p, false)
	or p.sunkydiagspring
	or (p.pflags & PF_STASIS)
	or p.mo.state == S_SUNKY_SWIMTURN
		return false
	end
	return true
end

addHook("PlayerSpawn", function(p)
	p.sunkyangle = p.mo.angle
	p.sunkylanded = false
	p.sunkysprung = false
	p.sunkyjump = false
	p.sunkyfall = false
	p.sunkyslope = false
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "sunky" p.sunkyangle = nil return end
	
	p.powers[pw_underwater] = 0 -- no drowning allowed
	p.powers[pw_spacetime] = 0 -- i still dont allow drowning
	
	if p.playerstate == PST_REBORN
		p.mo.spritexscale = FU
		p.mo.spriteyscale = FU
	end
	
	local mang = R_PointToAngle2(0, 0, p.cmd.forwardmove*FU, -p.cmd.sidemove*FU)
	
	if p.sunkyangle == nil
		p.sunkyangle = p.mo.angle
	end
	local umang = p.mo.angle+mang
	if displayplayer
	and camera.chase
		umang = camera.angle+mang
	end
	local tang = p.sunkyangle+ANGLE_180
	
	if (p.cmd.forwardmove or p.cmd.sidemove)
	and shouldMove(p)
		local tspeed = FU
		local mspeed = 5*FU
		--mspeed = 18*FU
		if p.mo.state == S_SUNKY_SWIM
			mspeed = 10*FU
		end
		P_InstaThrust(p.mo, p.sunkyangle, tspeed)
		if P_GetPlayerControlDirection(p) == 2
		and p.mo.state ~= S_PLAY_BOUNCE_LANDING
		and p.mo.state ~= S_SUNKY_FAN
		and not p.sunkysprung
			if p.mo.state == S_SUNKY_SWIM
				p.mo.state = S_SUNKY_SWIMTURN
			else
				p.mo.state = S_SUNKY_TURN
			end
			p.sunkyturnang = p.drawangle
		else
			P_InstaThrust(p.mo, umang, mspeed)
			p.sunkymoved = true
		end
		p.sunkyangle = umang
	elseif shouldMove(p)
	and p.mo.state ~= S_SUNKY_SWIM
		P_InstaThrust(p.mo, 0, 0)
	end
	
	if p.powers[pw_carry] == CR_FAN
	and p.mo.state ~= S_SUNKY_FAN
		p.mo.state = S_SUNKY_FAN
	end
	
	if (p.mo.eflags & MFE_SPRUNG)
		p.sunkysprung = true
		p.mo.state = S_SUNKY_SPRING
	end
	
	if (p.pflags & PF_STARTJUMP)
	and not p.sunkysprung
		p.pflags = $ & ~PF_STARTJUMP
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = -$
		p.sunkyjump = true
	end
	
	if p.mo.state == S_PLAY_BOUNCE_LANDING
		p.mo.eflags = $ & ~MFE_JUSTHITFLOOR
	end
	
	if (p.mo.eflags & MFE_JUSTHITFLOOR)
		if p.sunkyjump
			p.mo.state = S_SUNKY_JUMP
			p.sunkyjump = false
		elseif p.mo.state ~= S_PLAY_BOUNCE_LANDING
		and not p.sunkysprung
		and not (p.mo.eflags & MFE_UNDERWATER)
		and not dontdoStuff(p)
			S_StartSound(p.mo, sfx_snkfl2)
			p.sunkylanded = true
		end
	end
	
	if p.mo.state == S_SUNKY_JUMP
	or p.mo.state == S_SUNKY_TURN
	or p.mo.state == S_SUNKY_SWIMTURN
	or p.mo.state == S_PLAY_FALL
		local frame = (p.mo.frame & FF_FRAMEMASK)
		p.mo.momx = 0
		p.mo.momy = 0
		if p.mo.state == S_PLAY_FALL
		and not p.sunkysprung
			if frame ~= V
				p.mo.tics = min($, 2)
				p.mo.momz = 0
			else
				P_SetObjectMomZ(p.mo, P_GetMobjGravity(p.mo)*P_MobjFlip(p.mo), true)
			end
		end
		p.pflags = $1|PF_FULLSTASIS
		if p.mo.state == S_SUNKY_TURN
		or p.mo.state == S_SUNKY_SWIMTURN
			local swim = (p.mo.state == S_SUNKY_SWIMTURN and true) or false
			if frame >= Q
			and not swim
			or frame >= D
			and swim
				p.drawangle = p.sunkyangle
				if frame >= W
				and not swim
				or frame >= E
				and swim
					p.pflags = $ & ~PF_FULLSTASIS
					if (p.cmd.forwardmove or p.cmd.sidemove)
						p.sunkyangle = umang
					end
				end
			else
				p.drawangle = p.sunkyturnang
				if frame == A
				and not S_SoundPlaying(p.mo, sfx_snktrn)
				and not swim
					S_StartSound(p.mo, sfx_snktrn)
				end
			end
		end
	end
	
	if p.mo.state == S_PLAY_DEAD
	and (p.mo.frame & FF_FRAMEMASK) == H
		p.mo.anim_duration = -1
	end
	
	if p.mo.state == S_PLAY_FALL
	and (p.mo.frame & FF_FRAMEMASK) == V
		p.mo.tics = -1
	end
	
	if p.powers[pw_justlaunched] ~= 0
	and p.mo.momz >= 0
		p.sunkyslope = true
	end
	
	if P_IsObjectOnGround(p.mo)
		if p.sunkysprung
			S_StartSound(p.mo, sfx_snkfcp)
			p.mo.state = S_PLAY_BOUNCE_LANDING
			P_InstaThrust(p.mo, p.drawangle, 7*FU)
			p.sunkysprung = false
		end
		if p.sunkyfall
			S_StopSoundByID(p.mo, sfx_snkfl1)
			--S_StartSound(p.mo, sfx_snkfl2)
			p.sunkyfall = false
		end
		p.sunkyslope = false
		p.sunkydiagspring = false
	else
		if not (p.pflags & PF_JUMPED)
		and not p.powers[pw_carry]
		and not (p.pflags & PF_SLIDING)
		and not p.sunkysprung
		and not p.sunkyslope
		and not p.sunkyfall
		and p.mo.momz*P_MobjFlip(p.mo) <= 0
		and p.mo.state ~= S_SUNKY_SWIM
		and p.mo.state ~= S_SUNKY_SWIMTURN
		and p.mo.state ~= S_SUNKY_FAN
		and not dontdoStuff(p)
			S_StartSound(p.mo, sfx_snkfl1)
			p.mo.state = S_PLAY_FALL
			p.sunkyfallt = {}
			p.sunkyfall = true
		end
		
		if p.sunkyfall
		and not dontdoStuff(p)
		and not p.sunkysprung
		and p.mo.state ~= S_SUNKY_REACH
			local f = p.sunkyfallt
			if p.mo.state ~= S_PLAY_FALL
				p.mo.state = S_PLAY_FALL
				p.mo.tics = f.tics
				p.mo.frame = f.frame
			else
				f.tics = p.mo.tics
				f.frame = p.mo.frame
			end
		elseif p.sunkyfall
		and (dontdoStuff(p) or p.sunkysprung or p.mo.state == S_SUNKY_REACH)
			p.sunkyfall = false
		end
	end
	
	/*if not P_IsObjectOnGround(p.mo)
		local umomz = min(abs(p.mo.momz)/25, FU)
		local xease = ease.linear(umomz, FU, FU/2)
		local yease = ease.linear(umomz, FU, FU+FU/3)
		p.mo.spritexscale = xease
		p.mo.spriteyscale = yease
	end*/
	
	if p.sunkylanded
		if p.sunkyland == nil
			p.sunkyland = {
				time = 0,
				oldscale = {
					[0] = p.mo.spritexscale,
					[1] = p.mo.spriteyscale
				}
			}
		end
		local l = p.sunkyland
		l.time = $+1
		if l.time > TICRATE/3
		or dontdoStuff(p)
			p.sunkylanded = false
			p.mo.spritexscale = l.oldscale[0]
			p.mo.spriteyscale = l.oldscale[1]
		else
			local ut = FixedDiv(l.time, TICRATE/3)
			local xease = ease.linear(ut, l.oldscale[0]*2, l.oldscale[0])
			local yease = ease.linear(ut, l.oldscale[1]/2, l.oldscale[1])
			p.mo.spritexscale = xease
			p.mo.spriteyscale = yease
		end
	elseif p.sunkyland ~= nil
		local l = p.sunkyland
		p.mo.spritexscale = (($ ~= l.oldscale[0]) and l.oldscale[0]) or $
		p.mo.spriteyscale = (($ ~= l.oldscale[1]) and l.oldscale[1]) or $
		p.sunkyland = nil
	end
end)

local diagsprings = {
	MT_YELLOWDIAG,
	MT_REDDIAG,
	MT_BLUEDIAG
}

local function diag(spring, pmo)
	if not (pmo.player and pmo.player.valid) return end
	
	local p = pmo.player
	
	p.sunkydiagspring = true
end

for i = 1, #diagsprings do
	addHook("MobjCollide", diag, diagsprings[i])
	addHook("MobjMoveCollide", diag, diagsprings[i])
end

addHook("ShouldDamage", function(pmo, inf, src, _, dmg)
	local p = pmo.player
	if pmo.skin ~= "sunky" return end
	
	if dmg == DMG_DROWNED
	or dmg == DMG_SPACEDROWN return false end -- IF you somehow drown, then don't.
	
	if dmg == DMG_SPIKE
		dmg = DMG_INSTAKILL
	end
	P_KillMobj(pmo, inf, src, dmg)
	pmo.momz = -$
	if dmg ~= DMG_DEATHPIT
		pmo.flags = MF_NOGRAVITY
		if dmg == DMG_CRUSHED
			pmo.state = S_PLAY_STND
			pmo.spritexscale = $*3
			pmo.spriteyscale = $/5
		end
	else
		S_StopSound(pmo)
		pmo.state = S_PLAY_STND
		pmo.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
	end
	return false
end, MT_PLAYER)