
-- he's accurate now
-- haha

local function dontdoStuff(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or (p.pflags & PF_SLIDING)
	or p.powers[pw_carry]
		return true
	end
	return false
end

local function shouldgoUp(p)
	if p.mo.z+p.mo.height >= p.mo.watertop-5*FU and not (p.mo.eflags & MFE_VERTICALFLIP)
	or p.mo.z+p.mo.height <= p.mo.floorz+2*FU and not (p.mo.eflags & MFE_VERTICALFLIP)
		return false
	end
	return true
end

local function shouldgoDown(p)
	if p.mo.z <= p.mo.watertop-5*FU and (p.mo.eflags & MFE_VERTICALFLIP)
	or p.mo.z <= p.mo.ceilingz-2*FU and (p.mo.eflags & MFE_VERTICALFLIP)
		return false
	end
	return true
end

addHook("PlayerSpawn", function(p)
	p.sunkyswimdelay = 0
	p.sunkyverticalswim = nil
	p.sunkymoved = false
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "sunky" return end
	
	if (p.mo.eflags & MFE_UNDERWATER)
	and not p.sunkysprung
	and not (p.mo.eflags & MFE_SPRUNG)
	and p.mo.state ~= S_SUNKY_REACH
	and not dontdoStuff(p)
		p.pflags = $1|PF_JUMPSTASIS
		if p.sunkyfall
			p.sunkyswimdelay = 7
			S_StartSound(p.mo, sfx_snkspl)
		end
		
		local momz = 0
		if (p.cmd.buttons & BT_JUMP)
			momz = 4*FU
			p.sunkyverticalswim = 2*FU
		elseif (p.cmd.buttons & BT_SPIN)
			momz = -10*FU
			p.sunkyverticalswim = -2*FU
		end
		
		if p.sunkyswimdelay
			p.sunkyswimdelay = $-1
			momz = -13*FU
			p.sunkyverticalswim = -2*FU
			p.pflags = $1|PF_STASIS
		end
		
		if p.sunkyverticalswim
		and p.sunkyverticalswim > 0
		and not shouldgoUp(p)
		or p.sunkyverticalswim
		and p.sunkyverticalswim < 0
		and not shouldgoDown(p)
			p.sunkyverticalswim = 0
		end
		
		if momz == 0
		and p.sunkyverticalswim ~= nil
		and not (p.cmd.forwardmove or p.cmd.sidemove)
			momz = p.sunkyverticalswim
			p.sunkymoved = false
		elseif (p.cmd.forwardmove or p.cmd.sidemove)
			p.sunkyverticalswim = nil
		end
		
		if not (p.cmd.forwardmove or p.cmd.sidemove)
		and p.mo.state ~= S_SUNKY_SWIMTURN
		and p.sunkymoved
			if momz == 0
				P_InstaThrust(p.mo, p.sunkyangle, 2*FU)
			else
				P_InstaThrust(p.mo, 0, 0)
			end
		end
		
		p.sunkyfall = false
		p.sunkylanded = false
		if momz*P_MobjFlip(p.mo) > 0
		and shouldgoUp(p)
		or momz*P_MobjFlip(p.mo) < 0
		and shouldgoDown(p)
		or momz <= 0
			P_SetObjectMomZ(p.mo, momz)
		elseif momz*P_MobjFlip(p.mo) > 0
		and not shouldgoUp(p)
		or momz*P_MobjFlip(p.mo) < 0
		and not shouldgoDown(p)
			P_SetObjectMomZ(p.mo, 0)
		end
		if p.mo.state ~= S_SUNKY_SWIM
		and p.mo.state ~= S_SUNKY_SWIMTURN
			p.mo.state = S_SUNKY_SWIM
		end
	elseif p.mo.state == S_SUNKY_SWIM
		p.mo.state = S_SUNKY_JUMP
	else
		p.sunkyverticalswim = nil
		p.sunkymoved = false
	end
end)